﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ProgramInventoryPOC
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataRow row = null;
            DataSet ds = new DataSet();
            DataTable parent = ds.Tables.Add("SeriesTable");
            //parent.Columns.Add("id", typeof(int)).AutoIncrement = true;
            //parent.Columns.Add("Column 1", typeof(string)).DefaultValue = "Column 1";
            //parent.Columns.Add("Column 2", typeof(string)).DefaultValue = "Column 2";

            // Parent Table
           // parent = new DataTable("SeriesTable");
            DataColumn col3 = new DataColumn("Name", typeof(string));
            parent.Columns.Add(col3);

            DataColumn col4 = new DataColumn("SeriesCde", typeof(int));
            parent.Columns.Add(col4);

            DataColumn col5 = new DataColumn("ActiveInd", typeof(string));
            parent.Columns.Add(col5);

           

            DataTable level1 = ds.Tables.Add("Table1");
            level1.Columns.Add("SeriesCde", typeof(int));
            level1.Columns.Add("Summary Value", typeof(string));

            ds.Relations.Add("MiddleTable1", parent.Columns["SeriesCde"], level1.Columns["SeriesCde"]);



            DataTable dt = ds.Tables.Add("Episode");
            //dt = new DataTable("Episode");
            //Me.dsTreeResult.Tables.Add("Customers")

            DataColumn col0 = new DataColumn("EpisodeCde", typeof(int));
            dt.Columns.Add(col0);

            DataColumn col1 = new DataColumn("Name", typeof(string));
            dt.Columns.Add(col1);

            DataColumn col2 = new DataColumn("SeriesCde", typeof(int));
            dt.Columns.Add(col2);

            dt.Rows.Clear();
            row = null;

           
           

            DataTable middleDT = parent.DataSet.Tables.Add(string.Format("Middle{0}", "Episode"));
            middleDT.Columns.Add("SeriesCde", typeof(int));
            middleDT.Columns.Add("EpisodeCde", typeof(int));
            middleDT.Columns.Add("Summary Value", typeof(string));
           // middleDT.Rows.Add("205", "V");
            level1.DataSet.Relations.Add(string.Format("MiddleRelation{0}", middleDT.TableName), level1.Columns["SeriesCde"], middleDT.Columns["SeriesCde"]);

            level1.DataSet.Relations.Add(string.Format("TableRelation{0}", "Episode"), middleDT.Columns["EpisodeCde"], dt.Columns["EpisodeCde"]);

            parent.Rows.Clear();
            row = null;
            row = parent.NewRow();
            parent.Rows.Add("Friends", 1024, "1");
            parent.Rows.Add("Dora", 1056, "1");
            parent.Rows.Add("All Grown Ups", 6523, "0");
            //geneareTable("Episode", ds.Tables["SeriesTable"], "SeriesCde", dt);
            // ROW 0

            row = row = level1.NewRow();
            level1.Rows.Add(1024, "");
            level1.Rows.Add(1056, "");

            row = row = middleDT.NewRow();
            middleDT.Rows.Add(1024,101, "");
            middleDT.Rows.Add(1024,102, "");
            middleDT.Rows.Add(1024,103, "");
            middleDT.Rows.Add(1056,201, "A");
            middleDT.Rows.Add(1056,205, "V");

            row = dt.NewRow();
            dt.Rows.Add(101, "One with Chandler", 1024);
            dt.Rows.Add(102, "One with Monica", 1024);
            dt.Rows.Add(103, "The One with the Blackout", 1024);
            dt.Rows.Add(201, "A", 1056);
            dt.Rows.Add(205, "V", 1056);

            DataTable dt2 = ds.Tables.Add("VersionTable");
           
            DataColumn col6 = new DataColumn("VersionCde", typeof(string));
            dt2.Columns.Add(col6);

            DataColumn col7 = new DataColumn("SeriesCde", typeof(string));
            dt2.Columns.Add(col7);

            DataColumn col8 = new DataColumn("EpisodeCde", typeof(string));
            dt2.Columns.Add(col8);

            DataColumn col9 = new DataColumn("Name", typeof(string));
            dt2.Columns.Add(col9);

            dt2.Rows.Clear();
            row = null;
            row = dt2.NewRow();
           

            DataTable middleDT1 = parent.DataSet.Tables.Add(string.Format("Middle{0}", "VersionTable"));
            middleDT1.Columns.Add("SeriesCde", typeof(int));
            middleDT1.Columns.Add("VersionCde", typeof(string));
            middleDT1.Columns.Add("Summary Value", typeof(string));

            level1.DataSet.Relations.Add(string.Format("MiddleRelation{0}", middleDT1.TableName), level1.Columns["SeriesCde"], middleDT1.Columns["SeriesCde"]);

            level1.DataSet.Relations.Add(string.Format("TableRelation{0}", "VersionTable"), middleDT1.Columns["VersionCde"], dt2.Columns["VersionCde"]);

            dt2.Rows.Add("584104", "1024", "101", "Full Screen Credits");
            dt2.Rows.Add("584101", "1024", "101", "Flash Credits");
            dt2.Rows.Add("584114", "1024", "101", "Original Version");
            dt2.Rows.Add("584154", "1056", "201", "HD Version");
            dt2.Rows.Add("584124", "1024", "102", "Original HD Version");
            dt2.Rows.Add("584564", "1024", "103", "Original Version");
           
            //NEED TO ADD RELATIONS FOR BELOW COMMENTED CODE


            //DataTable dt3 = null;
            //dt3 = new DataTable("clipTable");
            //DataColumn col10 = new DataColumn("VersionCde", typeof(string));
            //dt3.Columns.Add(col10);

            //DataColumn col11 = new DataColumn("SeriesCde", typeof(string));
            //dt3.Columns.Add(col11);

            //DataColumn col12 = new DataColumn("EpisodeCde", typeof(string));
            //dt3.Columns.Add(col12);

            //DataColumn col13 = new DataColumn("Name", typeof(string));
            //dt3.Columns.Add(col13);

            //DataColumn col14 = new DataColumn("ClipCde", typeof(string));
            //dt3.Columns.Add(col14);

            //DataTable middleDT2 = parent.DataSet.Tables.Add(string.Format("Middle{0}", "VersionTable"));

            //middleDT2.Columns.Add("SeriesCde", typeof(string));
            //middleDT2.Columns.Add("ClipCde", typeof(string));
            //middleDT2.Columns.Add("Summary Value", typeof(string));
            //level1.DataSet.Relations.Add(string.Format("MiddleRelation{0}", middleDT2.TableName), level1.Columns["SeriesCde"], middleDT2.Columns["SeriesCde"]);

            //level1.DataSet.Relations.Add(string.Format("TableRelation{0}", "VersionTable"), middleDT2.Columns["ClipCde"], dt.Columns["ClipCde"]);

            //dt3.Rows.Clear();
            //row = null;
            //row = dt3.NewRow();
            //dt3.Rows.Add("584104", "1024", "101", "Full Screen Credits", "236");
            //dt3.Rows.Add("584101", "1024", "101", "Flash Credits", "546");
            //dt3.Rows.Add("584114", "1024", "101", "Original Version", "5586");
            //dt3.Rows.Add("584154", "1056", "201", "HD Version", "587");
            //dt3.Rows.Add("584104", "1024", "102", "Original HD Version", "268");
            //dt3.Rows.Add("584104", "1024", "103", "Original Version", "761");


            //DataTable dt4 = null;
            //dt4 = new DataTable("LicenseTable");
            //DataColumn col15 = new DataColumn("licenseCde", typeof(string));
            //dt4.Columns.Add(col15);

            //DataColumn col16 = new DataColumn("SeriesCde", typeof(string));
            //dt4.Columns.Add(col16);

            //DataColumn col17 = new DataColumn("EpisodeCde", typeof(string));
            //dt4.Columns.Add(col17);

            //dt4.Rows.Clear();
            //row = null;
            //row = dt4.NewRow();
            //dt4.Rows.Add("584104", "1024", "101");
            //dt4.Rows.Add("584101", "1024", "101");
            //dt4.Rows.Add("584114", "1024", "102");
            //dt4.Rows.Add("584154", "1056", "201");
            //dt4.Rows.Add("584104", "1024", "102");
            //dt4.Rows.Add("584104", "1024", "103");

            //geneareTable("License", ds.Tables["Table1"], "id", dt4);

            //DataTable dt5 = null;
            //dt5 = new DataTable("summaryTable");
            //DataColumn col18 = new DataColumn("summaryCde", typeof(string));
            //dt5.Columns.Add(col18);

            //DataColumn col19 = new DataColumn("SeriesCde", typeof(string));
            //dt5.Columns.Add(col19);

            //DataColumn col20 = new DataColumn("EpisodeCde", typeof(string));
            //dt5.Columns.Add(col20);

            //DataColumn col21 = new DataColumn("Text", typeof(string));
            //dt5.Columns.Add(col21);


            //dt5.Rows.Clear();
            //row = null;
            //row = dt5.NewRow();
            //dt5.Rows.Add("584104", "1024", "101", "Full Screen Credits");
            //dt5.Rows.Add("584101", "1024", "101", "Flash Credits");
            //dt5.Rows.Add("584114", "1024", "201", "Original Version");
            //dt5.Rows.Add("584154", "1056", "201", "HD Version");
            //dt5.Rows.Add("584104", "1024", "102", "Original HD Version");
            //dt5.Rows.Add("584104", "1024", "103", "Original Version");

            //DataTable dt6 = null;
            //dt6 = new DataTable("clipSummary");
            
            //DataColumn col22 = new DataColumn("summaryCde", typeof(string));
            //dt6.Columns.Add(col22);

            //DataColumn col23 = new DataColumn("Text", typeof(string));
            //dt6.Columns.Add(col23);

            //DataColumn col24 = new DataColumn("clipCde", typeof(string));
            //dt6.Columns.Add(col24);

            //dt6.Rows.Clear();
            //row = null;

            // //ROW 0
            //row = dt6.NewRow();
            //dt6.Rows.Add("101", "One with Chandler", "236");
            //dt6.Rows.Add("102", "One with Monica", "236");
            //dt6.Rows.Add("103", "The One with the Blackout", "546");
            //dt6.Rows.Add("201", "A", "546");
            //dt6.Rows.Add("205", "V", "156");

            //DataTable dt7 = null;
            //dt7 = new DataTable("versionSummary");
            //DataColumn col25 = new DataColumn("summaryCde", typeof(string));
            //dt7.Columns.Add(col25);

            //DataColumn col26 = new DataColumn("SeriesCde", typeof(string));
            //dt7.Columns.Add(col26);

            //DataColumn col27 = new DataColumn("EpisodeCde", typeof(string));
            //dt7.Columns.Add(col27);

            //DataColumn col28 = new DataColumn("Text", typeof(string));
            //dt7.Columns.Add(col28);

            //DataColumn col29 = new DataColumn("versionCde", typeof(string));
            //dt7.Columns.Add(col29);

            //dt7.Rows.Clear();
            //row = null;
            //row = dt7.NewRow();
            //dt7.Rows.Add("584104", "1024", "101", "Full Screen Credits", "584114");
            //dt7.Rows.Add("584101", "1024", "101", "Flash Credits", "564");
            //dt7.Rows.Add("584114", "1024", "101", "Original Version", "584114");
            //dt7.Rows.Add("584154", "1056", "201", "HD Version", "564");
            //dt7.Rows.Add("584104", "1024", "102", "Original HD Version", "595");
            //dt7.Rows.Add("584104", "1024", "103", "Original Version", "584154");

            //DataTable dt8 = null;
            //dt8 = new DataTable("SeriesLicense");
            //DataColumn col30 = new DataColumn("SeriesCde", typeof(string));
            //dt8.Columns.Add(col30);

            //DataColumn col31 = new DataColumn("LicenseCde", typeof(string));
            //dt8.Columns.Add(col31);

            //DataColumn col32 = new DataColumn("LicenseType", typeof(string));
            //dt8.Columns.Add(col32);


            //dt8.Rows.Clear();
            //row = null;
            //row = dt8.NewRow();
            //dt8.Rows.Add("1024", "563", "S");
            //dt8.Rows.Add("1024", "856", "S");
            //dt8.Rows.Add("1024", "265", "O");
            //dt8.Rows.Add("1056", "645", "O");
            //dt8.Rows.Add("6523", "320", "O");
            //dt8.Rows.Add("6523", "741", "S");

            //DataTable dt9 = null;
            //dt9 = new DataTable("SeriesVersion");
            //dt9 = dt2.Clone();

            
            udgProgramInventory.DataSource = ds;


        }

        private DataTable geneareTable(string tabelName, DataTable parentTable, string parentColumnId, DataTable dt)
        {
            //DataTable dt = parentTable.DataSet.Tables.Add(tabelName);
            //dt.Columns.Add("pid", typeof(int));
            //dt.Columns.Add("id", typeof(int)).AutoIncrement = true;
            //dt.Columns.Add("Row Type", typeof(string)).Expression = string.Format("'{0}'", tabelName);
            //dt.Columns.Add("Some Text", typeof(string)).DefaultValue = string.Format("Some test string for {0}", tabelName);

            DataTable middleDT = parentTable.DataSet.Tables.Add(string.Format("Middle{0}", tabelName));
            middleDT.Columns.Add(parentColumnId, typeof(string));
            middleDT.Columns.Add("Summary Value", typeof(string));

            parentTable.DataSet.Relations.Add(string.Format("MiddleRelation{0}", middleDT.TableName), parentTable.Columns[parentColumnId], middleDT.Columns[parentColumnId]);

            parentTable.DataSet.Relations.Add(string.Format("TableRelation{0}", tabelName), middleDT.Columns[parentColumnId], dt.Columns["SeriesCde"]);

            return dt;
        }

        private void udgProgramInventory_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {

            e.Layout.Override.AllowColSizing = AllowColSizing.Free;

            foreach (UltraGridBand band in e.Layout.Bands)
            {
                if (band.Key.StartsWith("Middle"))
                    AdjustMiddleBand(band);
            }
        }

        private void AdjustMiddleBand(UltraGridBand band)
        {
            band.ColHeadersVisible = false;
            band.Columns[0].Hidden = true;
            band.Columns[1].Width = 500;
            band.Columns[1].CellActivation = Activation.ActivateOnly;
            band.Override.RowSelectors = Infragistics.Win.DefaultableBoolean.False;
            band.Override.BorderStyleCell = Infragistics.Win.UIElementBorderStyle.None;
            band.Override.BorderStyleRow = Infragistics.Win.UIElementBorderStyle.None;
        }

        private void udgProgramInventory_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            if (e.Row.Band.Key.StartsWith("Middle"))
            {
                StringBuilder label = new StringBuilder();
                label.Append("Row Type:");
                DataRow row = ((DataRowView)e.Row.ListObject).Row;
                foreach (DataRelation rel in row.Table.ChildRelations)
                {
                    int childRowsCount = -1;
                    string childTableName = "None";
                    GetchildRowTable(ref childRowsCount, ref childTableName, row, rel);
                    label.AppendFormat("{0} ({1} items), ", childTableName, childRowsCount);
                }

                e.Row.Cells[1].Value = label.ToString();
            }
        }

        private void GetchildRowTable(ref int childRowsCount, ref string childTableName, DataRow row, DataRelation rel)
        {
            if (rel.RelationName.StartsWith("Middle"))
            {
                DataRow middRow = row.GetChildRows(rel).FirstOrDefault();
                int count = row.GetChildRows(rel).Count();
                List<DataRow> middRows = row.GetChildRows(rel).ToList();

                foreach (DataRow item in middRows)
                {
                    if (item != null)
                    {
                        GetchildRowTable(ref childRowsCount, ref childTableName, item, item.Table.ChildRelations[0]);
                    }
                    
                }
                
            }
            else
            {
                childRowsCount = row.GetChildRows(rel).Count();
                childTableName = rel.ChildTable.TableName;
            }

        }
    }
}
